# Nim JWT

This is a standards-compliant implementation of the JWT, JWK, JWS, and JWE
standards in Nim, using the [BearSSL](https://www.bearssl.org/) library to
provide the underlying cryptographic primatives.

## Supported Algorithms (JWA)

[RFC7518 (JWA)][rfc7518] registers
cryptographic algorithms and identifiers to be used with the JSON Web Signature
(JWS), JSON Web Encryption (JWE), and JSON Web Key (JWK) specifications.

This library supports all REQUIRED algorithms. Specifically, the following
algorithms are supported:

### Digital Signature and MACs (JWS)

From [RFC7518 section 3][rfc7518-s3] the following algorithms are supported:

* *TBD*

### Key Management

From [RFC7518 section 4][rfc7518-s4] the following algorithms are supported:

* *TBD*

### Content Encryption

From [RFC7518 section 5][rfc7518-s5] the following algorithms are supported:

* *TBD*

### Keys

From [RFC7518 section 6][rfc7518-s6] the following key types are supported:

* EC
* RSA
* otc

[rfc7518]: https://datatracker.ietf.org/doc/html/rfc7518
[rfc7518-s3]: https://datatracker.ietf.org/doc/html/rfc7518#section-3
[rfc7518-s4]: https://datatracker.ietf.org/doc/html/rfc7518#section-4
[rfc7518-s5]: https://datatracker.ietf.org/doc/html/rfc7518#section-5
[rfc7518-s6]: https://datatracker.ietf.org/doc/html/rfc7518#section-6
