import std/base64, std/strutils

proc b64UrlEncode*(s: string): string =
  result = encode(s, safe = true)
  while result.endsWith("="):
    result.setLen(result.len - 1)

proc b64UrlEncode*[T: SomeInteger | char](arr: openarray[T]): string =
  result= encode(arr, safe = true)
  while result.endsWith("="):
    result.setLen(result.len - 1)

proc b64UrlDecode*(s: string): string =
  var withPadding = s
  while withPadding.len mod 4 > 0:
    withPadding &= "="
  result = decode(withPadding)

func byteArrToString*[T: SomeInteger | char](arr: openarray[T]): string =
  result = newString(arr.len)
  for i in 0..<arr.len:
    result[i] = cast[char](arr[i])
