import std/json, std/options, std/unittest

import jwt_full/jwa
import jwt_full/joseheader

import ../testdata

suite "jwt_full/joseheader":

  test "initJoseHeader always sets rawB64":
    let h1 = initJoseHeader(rfc7519_S31_HeaderB64)
    let h2 = initJoseHeader(parseJson(rfc7519_S31_HeaderStr))
    let h3 = initJoseHeader(alg = some(HS256), typ = some("JWT"))

    check:
      h1.rawB64 == rfc7519_S31_HeaderB64
      h2.rawB64 == "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9"
      h3.rawB64 == "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9"
